// @@@@@@@@@@ Original Code by TechMartian
// @@@@@@@@@@ From https://www.instructables.com/id/Pocket-Size-Ultrasonic-Measuring-Tool-With-ESP32/


//wifi
#include <WiFi.h>
#include <HTTPClient.h>

const char* ssid = "Wifi Name";
const char* password =  "Wifi Password";

IPAddress local_IP(172, 20, 10, 12);  // Static IP for your ESP32
IPAddress gateway(172, 20, 10, 1);    // Gateway IP
IPAddress subnet(255, 255, 255, 240); // Subnetmask

// defines pins numbers
const int trigPin = 2;
const int echoPin = 0;

// defines variables
long duration;
int distance;

void setup() {
  pinMode(trigPin, OUTPUT); // Sets the trigPin as an Output
  pinMode(echoPin, INPUT); // Sets the echoPin as an Input
  Serial.begin(115200); // Starts the serial communication

  //wifi
  WiFi.config(local_IP, gateway, subnet);
 
  WiFi.begin(ssid, password);
 
  while (WiFi.status() != WL_CONNECTED) {
    delay(1000);
    Serial.println("Connecting to WiFi..");
  }
 
  Serial.println("Connected to the WiFi network");
  Serial.println(WiFi.localIP());
}

void loop() {
  // Clears the trigPin
  digitalWrite(trigPin, LOW);
  delayMicroseconds(2);

  // Sets the trigPin on HIGH state for 10 micro seconds
  digitalWrite(trigPin, HIGH);
  delayMicroseconds(10);
  digitalWrite(trigPin, LOW);

  // Reads the echoPin, returns the sound wave travel time in microseconds
  duration = pulseIn(echoPin, HIGH);

  // Calculating the distance
  distance = duration*0.034/2;

  // Prints the distance on the Serial Monitor
  Serial.print("Distance: ");
  Serial.println(distance);

  //wifi
  if(distance < 50){
    if(WiFi.status()== WL_CONNECTED){   //Check WiFi connection status
   
     HTTPClient http;   
   
     http.begin("http://172.20.10.8:8090/detected");
     http.addHeader("Content-Type", "text/plain");             
     
     int httpResponseCode = http.POST("2");   //Send the actual POST request
   
     if(httpResponseCode>0){
   
      Serial.println(httpResponseCode); 
   
     }else{
   
      Serial.println("Error on sending POST");
   
     }
   
     http.end();  //Free resources
   
     }else{
   
      Serial.println("Error in WiFi connection");   
   
     }
    delay(5000);
  }else{
    delay(1000);
  }
}
